SystemOrganization addCategory: #'Kinect-Etoys'!

EllipseMorph subclass: #KinectJointMorph
	instanceVariableNames: 'jointPosition jointState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kinect-Etoys'!

!KinectJointMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 9/10/2012 16:21'!
additionsToViewerCategories
	^ # ((kinect (
(slot jointX '' Number readOnly Player getJointX unused unused)
(slot jointY '' Number readOnly Player getJointY unused unused)
(slot jointZ '' Number readOnly Player getJointZ unused unused)
(slot jointState '' JointState readOnly Player getJointState unused unused)
)))
! !

!KinectJointMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 9/12/2012 16:44'!
initialize
	"
	self initialize
	"
	'inferred' translatedNoop.
	'tracked' translatedNoop.
	Vocabulary addStandardVocabulary: (SymbolListType new vocabularyName: #JointState;
			 symbols: #( #inferred #tracked)).! !

!KinectJointMorph methodsFor: 'viewer category filter' stamp: 'Richo 9/10/2012 16:38'!
categoriesForViewer
	^self validCategories , #(scripting)! !

!KinectJointMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 16:24'!
jointState
	^ jointState! !

!KinectJointMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 16:24'!
jointX
	^ jointPosition x! !

!KinectJointMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 16:24'!
jointY
	^ jointPosition y! !

!KinectJointMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 16:24'!
jointZ
	^ jointPosition z! !

!KinectJointMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 16:35'!
newPlayerInstance
	^ KinectPlayer newUserInstance! !

!KinectJointMorph methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:14'!
position: aPoint3D tracked: trackedBool
	jointPosition := aPoint3D.
	jointState := trackedBool ifTrue: [#tracked] ifFalse: [#inferred]! !

!KinectJointMorph methodsFor: 'viewer category filter' stamp: 'Richo 9/10/2012 16:38'!
validCategories
	"Returns valid categories"
	^ (self class additionsToViewerCategories collect: [:each| each first])! !

Player subclass: #KinectPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kinect-Etoys'!

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/12/2012 17:07'!
getCameraAngle
	^ self getValueFromCostume: #cameraAngle! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/10/2012 17:56'!
getIsStarted
	^ self getValueFromCostume: #isStarted! !

!KinectPlayer methodsFor: 'joint' stamp: 'Richo 9/10/2012 16:23'!
getJointState
	^ self getValueFromCostume: #jointState! !

!KinectPlayer methodsFor: 'joint' stamp: 'Richo 9/10/2012 16:23'!
getJointX
	^ self getValueFromCostume: #jointX! !

!KinectPlayer methodsFor: 'joint' stamp: 'Richo 9/10/2012 16:23'!
getJointY
	^ self getValueFromCostume: #jointY! !

!KinectPlayer methodsFor: 'joint' stamp: 'Richo 9/10/2012 16:23'!
getJointZ
	^ self getValueFromCostume: #jointZ! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/11/2012 13:13'!
getNumberOfPlayers
	^ self getValueFromCostume: #numberOfPlayers! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/10/2012 17:56'!
getServerType
	^ self getValueFromCostume: #serverType! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/12/2012 17:15'!
setCameraAngle: aNumber
	^ self setCostumeSlot: #cameraAngle: toValue: aNumber! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/11/2012 13:13'!
setNumberOfPlayers: aNumber
	^ self setCostumeSlot: #numberOfPlayers: toValue: aNumber! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/10/2012 17:58'!
setServerType: aNumber
	^ self setCostumeSlot: #serverType: toValue: aNumber! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/10/2012 17:54'!
start
	^ self sendMessageToCostume: #start! !

!KinectPlayer methodsFor: 'server' stamp: 'Richo 9/10/2012 17:54'!
stop
	^ self sendMessageToCostume: #stop! !

Morph subclass: #KinectServerMorph
	instanceVariableNames: 'skeleton kinectServer informationMorph serverType startBtn stopBtn typeBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kinect-Etoys'!

!KinectServerMorph class methodsFor: 'viewer categories' stamp: 'Richo 9/12/2012 17:06'!
additionsToViewerCategories
	^  {{#kinect .{
	{#command . #start . ''}.
	{#command . #stop . ''}.
	{#slot . #isStarted . '' . #Boolean . #readOnly . #Player . #getIsStarted . #unused . #unused}.
	{#slot . #cameraAngle . '' . #Number . #readWrite . #Player . #getCameraAngle . #Player . #setCameraAngle:}
	"{#slot . #numberOfPlayers . '' . #Number . #readWrite . #Player . #getNumberOfPlayers . #Player . #setNumberOfPlayers:}"
	}, 	
	(KinectServer serverTypes size > 1
		ifTrue: [{{#slot . #serverType . '' . #KinectServerType . #readWrite . #Player . #getServerType . #Player . #setServerType:}}]
		ifFalse: [{}])}}! !

!KinectServerMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 9/11/2012 15:19'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self partName: 	'Kinect Server' translatedNoop
		categories:		((PEUtilities isPEProject: Project current)
								ifTrue: [{'Physical Etoys' translatedNoop}]
								ifFalse: [#()])
		documentation:	''! !

!KinectServerMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 1/17/2011 16:50'!
includeInNewMorphMenu
	^true! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/11/2012 13:36'!
addButtons
	startBtn := (SimpleButtonMorph new label: ' Start ';
			position: self topLeft + 10;
			color: (Color green mixed: 0.3 with: Color blue muchLighter);
			borderColor: #raised;
			cornerStyle: #rounded;
			borderWidth: 2;
			actionSelector: #start;
			target: self).
	stopBtn := (SimpleButtonMorph new label: ' Stop ';
			position: startBtn bottomLeft + (0@10);
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			borderColor: #raised;
			cornerStyle: #rounded;
			borderWidth: 2;
			actionSelector: #stop;
			target: self).
	typeBtn := SimpleButtonMorph new.
	typeBtn
		label: ' ', serverType, ' ';
		topRight: self topRight + (-10@10);
		color: Color transparent;
		borderColor: Color gray;
		cornerStyle: #rounded;
		borderWidth: 2;
		actionSelector: #chooseServerType:;
		arguments: {typeBtn};
		target: self.
	self addMorph: startBtn;
		addMorph: stopBtn;
		addMorph: typeBtn.
	! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 1/17/2011 16:08'!
addJoints
	skeleton := Dictionary new.
	self initialJointPositions keysAndValuesDo: [:jointName :jointPos |
		self addMorph: (skeleton at: jointName put: (self newJointMorph setNameTo: jointName capitalized))].
	self positionJoints.! !

!KinectServerMorph methodsFor: 'kinect events' stamp: 'Richo 1/18/2011 18:46'!
calibrationStart: userId
	self show: 'Calibration started' forSeconds: 2! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/12/2012 17:23'!
cameraAngle
	^ kinectServer cameraAngle! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/12/2012 17:36'!
cameraAngle: angle
	kinectServer cameraAngle: (angle min: 27 max: -27)! !

!KinectServerMorph methodsFor: 'viewer category filter' stamp: 'Richo 9/10/2012 17:59'!
categoriesForViewer
	^self validCategories , #(scripting)! !

!KinectServerMorph methodsFor: 'button actions' stamp: 'Richo 9/11/2012 13:36'!
chooseServerType: button
	| values labels |
	values := KinectServer serverTypes keys asArray.
	values size <= 1 ifTrue: [^ self].
	labels := KinectServer serverTypes keys asArray collect: [:each | ' ', each, ' '].
	(UIManager chooseFrom: labels values: values)
		ifNotNil: [:choice |
			serverType = choice ifTrue: [^ self].
			self serverType: choice]! !

!KinectServerMorph methodsFor: 'halo' stamp: 'Richo 9/5/2012 18:14'!
defersHaloToInteriorMorph: aMorph
	"It only defers halo to interior if the morph is one of the skeleton's joints."
	^skeleton anySatisfy: [:each | each = aMorph]! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/5/2012 16:51'!
delete
	kinectServer stop.
	super delete! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 14:33'!
extent: newExtent
	"Updates the joint positions"
	super extent: newExtent.
	typeBtn ifNotNil: [:btn | btn topRight: self topRight + (-10@10)].
	skeleton ifNotNil: [self positionJoints].! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/11/2012 13:10'!
initialJointPositions
"Roughly imitating the calibration pose"
^{
	#hipCenter -> (0.0 @ -0.1 @ 0.44).
	#spine -> (0.0 @ 0.04000000000000003 @ 0.44).
	#shoulderCenter -> (0.0 @ 0.36 @ 0.44).
	#head -> (0.0 @ 0.58 @ 0.44).
	#shoulderLeft -> (-0.18 @ 0.36 @ 0.44).
	#elbowLeft -> (-0.44 @ 0.36 @ 0.44).
	#wristLeft -> (-0.44 @ 0.58 @ 0.44).
	#handLeft -> (-0.44 @ 0.64 @ 0.44).
	#shoulderRight -> (0.18 @ 0.36 @ 0.44).
	#elbowRight -> (0.44 @ 0.36 @ 0.44).
	#wristRight -> (0.44 @ 0.58 @ 0.44).
	#handRight -> (0.44 @ 0.64 @ 0.44).
	#hipLeft -> (-0.14 @ -0.18 @ 0.44).
	#kneeLeft -> (-0.16 @ -0.48 @ 0.44).
	#ankleLeft -> (-0.16 @ -0.72 @ 0.44).
	#footLeft -> (-0.2 @ -0.78 @ 0.44).
	#hipRight -> (0.14 @ -0.18 @ 0.44).
	#kneeRight -> (0.16 @ -0.48 @ 0.44).
	#ankleRight -> (0.16 @ -0.72 @ 0.44).
	#footRight -> (0.2 @ -0.78 @ 0.44).
} as: Dictionary! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/12/2012 16:44'!
initialize
	super initialize.
	self color: Color white;
		 borderColor: Color red;
		 borderWidth: 2;
		 clipSubmorphs: true; 
		 extent:  480.0@360.0.
	self initializeServerType;
		initializeKinectServer; 
		addJoints;
		addButtons.! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/12/2012 15:02'!
initializeKinectServer
	"Creates the Kinect server and configures its events"
	kinectServer := self newKinectServer.
	kinectServer when: #jointUpdate send: #updateJoint:position:tracked:user: to: self.
	kinectServer when: #newUser send: #newUser: to: self.
	kinectServer when: #lostUser send: #lostUser: to: self.
	kinectServer when: #poseDetected send: #poseDetected: to: self.
	kinectServer when: #calibrationStart send: #calibrationStart: to: self.
	kinectServer when: #newSkeleton send: #newSkeleton: to: self.! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/12/2012 14:59'!
initializeServerType
	Vocabulary 
		addStandardVocabulary: (SymbolListType new
			 vocabularyName: #KinectServerType;
			 symbols: KinectServer serverTypes keys asArray).
	serverType := (KinectServer serverTypes includesKey: #FFI)
		ifTrue: [#FFI]
		ifFalse: [KinectServer serverTypes atRandom key]
! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 17:58'!
isStarted
	^ kinectServer isStarted! !

!KinectServerMorph methodsFor: 'kinect events' stamp: 'Richo 1/18/2011 18:43'!
lostUser: userId
	self positionJoints; 
		 show: 'Lost user' forSeconds: 2! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/5/2012 18:17'!
newJointMorph
	^ KinectJointMorph new
		color: (Color blue alpha: 0.5);
		borderWidth: 0;
		extent: 45@45;
		yourself! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/11/2012 13:27'!
newKinectServer
	^ (KinectServer serverTypes at: serverType) new! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 17:53'!
newPlayerInstance
	^ KinectPlayer newUserInstance! !

!KinectServerMorph methodsFor: 'kinect events' stamp: 'Richo 1/18/2011 18:48'!
newSkeleton: userId
	self show: 'New skeleton' forSeconds: 1! !

!KinectServerMorph methodsFor: 'kinect events' stamp: 'Richo 1/18/2011 18:46'!
newUser: userId
	self show: 'New user' forSeconds: 2! !

!KinectServerMorph methodsFor: 'updating ui' stamp: 'Richo 9/10/2012 18:00'!
oldPosition: aMorph accordingTo: aPoint3D
	"Moves the morph to the relative position given as a parameter. It also changes its size and color depending on the point's z"
	| block |
	block := [aMorph extent: (self height min: self width) / 5 * (1 - aPoint3D z) * (1.1@1.1);
		 color: (Color blue alpha: (1 - aPoint3D z));
		 center: self topLeft + (aPoint3D x * self width @ (aPoint3D y * self height))].
	"Temporary hack to fix the slow performance of WorldState>>#addDeferredUIMessage: in Pharo. It's not a real solution, but until the underlying problem is fixed at least this makes it usable"
	"RunningInPharo"false ifTrue: [block value] ifFalse: [WorldState addDeferredUIMessage: block]! !

!KinectServerMorph methodsFor: 'kinect events' stamp: 'Richo 1/18/2011 18:46'!
poseDetected: userId
	self show: 'Pose detected' forSeconds: 2! !

!KinectServerMorph methodsFor: 'updating ui' stamp: 'Richo 9/12/2012 15:01'!
position: aMorph accordingTo: aPoint3D tracked: trackedBoolean
	"Moves the morph to the relative position given as a parameter. It also changes its size and color depending on the point's z
	The skeleton position data ranges are:

	Values of x range from approximately -1.0 to +1.0.
	Values of y range from approximately -1.0 to +1.0.
	Values of z range from 0.0 to 1.0.
	"
	WorldState addDeferredUIMessage: [| x y z c |
		aMorph
			position: aPoint3D
			tracked: trackedBoolean.

		x := aPoint3D x.
		y := aPoint3D y.
		z := aPoint3D z.
		c := trackedBoolean 
			ifTrue: [Color blue] 
			ifFalse: [Color red].
		
		aMorph 
			center: self center + ((x @ y) * (0.72 @ -1) * (self extent / 2));
			extent: (self height min: self width) / 4 * (1 - aPoint3D z) * (0.8 @ 0.8);
			color: (c alphaMixed: (1 - aPoint3D z) with: Color transparent)
		]! !

!KinectServerMorph methodsFor: 'initialize' stamp: 'Richo 9/12/2012 16:44'!
positionJoints
	"Moves all the joints to their initial position"
	self initialJointPositions keysAndValuesDo: [:jointName :jointPosition |
		self 
			position: (skeleton at: jointName)
			accordingTo: jointPosition
			tracked: false]! !

!KinectServerMorph methodsFor: 'fileIn/out' stamp: 'Richo 9/10/2012 16:37'!
prepareToBeSaved
	"When saving a project be sure to stop the server, otherwise we will have a lot of problems"
	super prepareToBeSaved.
	self stop! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 18:01'!
serverType
	^ serverType! !

!KinectServerMorph methodsFor: 'accessing' stamp: 'Richo 9/10/2012 18:02'!
serverType: aSymbol
	self stop.
	serverType := aSymbol.
	typeBtn
		label: ' ', aSymbol, ' ';
		topRight: self topRight + (-10@10).
	self initializeKinectServer! !

!KinectServerMorph methodsFor: 'updating ui' stamp: 'Richo 1/18/2011 18:48'!
show: aString forSeconds: aNumber
	"Shows a msg in the top of the morph"
	aString isEmpty ifTrue: [informationMorph ifNotNilDo: [:m | m delete]. informationMorph := nil. ^self].
	informationMorph isNil ifTrue: [self addMorph: (informationMorph := TextMorph new)].
	informationMorph contents: aString.
	informationMorph center: self center x @ (self top + informationMorph height).
	"Remove the message after x seconds"
	World addAlarm: #value withArguments: #() for: [informationMorph ifNotNilDo: [:m | m delete]. informationMorph := nil] at: (Time millisecondClockValue + (aNumber * 1000))! !

!KinectServerMorph methodsFor: 'button actions' stamp: 'Richo 9/10/2012 16:37'!
start
	""
	kinectServer start.
	self borderColor: Color green; startStepping! !

!KinectServerMorph methodsFor: 'button actions' stamp: 'Richo 9/10/2012 16:37'!
stop
	""
	kinectServer stop.
	self positionJoints.
	self borderColor: Color red; startStepping.
! !

!KinectServerMorph methodsFor: 'kinect events' stamp: 'Richo 9/12/2012 15:02'!
updateJoint: jointName position: jointPosition tracked: trackedBoolean user: userId
	self
		position: (skeleton at: jointName ifAbsent: [^self])
		accordingTo: jointPosition
		tracked: trackedBoolean! !

!KinectServerMorph methodsFor: 'viewer category filter' stamp: 'Richo 9/10/2012 17:59'!
validCategories
	^ (self class additionsToViewerCategories collect: [:each| each first])! !
KinectJointMorph initialize!
